org.deidentifier.arx.framework.check

## Class TransformationCheckerStateMachine

- java.lang.Object
- - org.deidentifier.arx.framework.check.TransformationCheckerStateMachine

    public class TransformationCheckerStateMachine
    extends java.lang.Object

This class implements a state machine, which determines which optimizations can be applied to the current transition depending on the previous transition.

Author:
  Fabian Prasser, Florian Kohlmayer

### Nested Class Summary

Nested Classes
`static class` `TransformationCheckerStateMachine.Transition` The resulting transition.
`static class` `TransformationCheckerStateMachine.TransitionType` The possible transition type.

### Constructor Summary

Constructors
Constructor and Description
`TransformationCheckerStateMachine(History history)` Instantiates a new state machine.

### Method Summary

All Methods Instance Methods Concrete Methods
`int[]` `getLastTransformation()` Returns the last transformation.
`TransformationCheckerStateMachine.Transition` `getLastTransition()` Returns the last transition.
`void` `reset()` Resets the state machine.
`TransformationCheckerStateMachine.Transition` `transition(int[] transformation)` Calculates the best state transition.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TransformationCheckerStateMachine

    public TransformationCheckerStateMachine(History history)

Instantiates a new state machine.

Parameters:
  `history` - the history

### Method Detail

#### getLastTransformation

    public int[] getLastTransformation()

Returns the last transformation.

Returns:
  the last transformation, which has been checked for k-anonymity

#### getLastTransition

    public TransformationCheckerStateMachine.Transition getLastTransition()

Returns the last transition.

Returns:

#### reset

    public void reset()

Resets the state machine.

#### transition

    public TransformationCheckerStateMachine.Transition transition(int[] transformation)

Calculates the best state transition.

Parameters:
  `transformation` - the current transformation
Returns:
  the transition